package install.doc.examples;

import java.io.*;
import java.net.URL;
import java.util.List;
import java.util.Map;
import java.util.logging.Logger;

import javax.activation.DataHandler;
import javax.activation.FileDataSource;
import javax.net.ssl.HostnameVerifier;
import javax.net.ssl.HttpsURLConnection;
import javax.net.ssl.SSLContext;
import javax.net.ssl.SSLSession;
import javax.net.ssl.TrustManager;
import javax.net.ssl.X509TrustManager;
import javax.xml.namespace.QName;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.ws.BindingProvider;
import javax.xml.ws.soap.MTOMFeature;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpression;
import javax.xml.xpath.XPathFactory;

import com.elpical.jclaro.ws.client.Account;
import com.elpical.jclaro.ws.client.JobImpl;
import com.elpical.jclaro.ws.client.JobImplService;
import com.elpical.jclaro.ws.client.JobStatus;
import com.elpical.util.PrintStackTrace;
import com.sun.xml.ws.developer.JAXWSProperties;
import com.sun.xml.ws.developer.StreamingAttachmentFeature;
import org.apache.commons.io.FilenameUtils;
import org.w3c.dom.Document;
import org.w3c.dom.Node;

/**
 * Example of how to use the Claro JobClient webservice 
 * 
 *
 */
public class ElpicalClaroWebservices_example {
	private static JobImpl port = null;
	
	static {
		// NOTE: This code prevents this error:
		// SSLHandshakeException: No subject alternative names present
		// 
		// Or this error: No subject alternative names matching IP address
		HttpsURLConnection.setDefaultHostnameVerifier(new HostnameVerifier() {
			/*
			 * (non-Javadoc)
			 * 
			 * @see javax.net.ssl.HostnameVerifier#verify(java.lang.String,
			 * javax.net.ssl.SSLSession)
			 */
			public boolean verify(String hostname, SSLSession session) {
				boolean result = false;
	
				// NOTE: Simply return true to allow everyone to use this example, but in production 
				// code this should NOT be the way to do it.
				result = true;
	
				return result;
			}
		});
	}

	/**
	 * Get the webservice port 
	 * 
	 * @param hostname
	 * @param portnumber
	 * @param timeout
	 * @param asMTOM
	 * @return
	 * @throws Exception
	 */
	public static JobImpl getPort(String hostname, int portnumber,int timeout,boolean asMTOM) throws Exception {
		URL url = null;
		URL baseUrl;
		baseUrl = com.elpical.jclaro.ws.client.JobImplService.class.getResource(".");
		url = new URL(baseUrl, "https://"+hostname+":"+portnumber+"/jclarojaxws/job?wsdl");
		JobImplService anis = new JobImplService(url, new QName("http://server.ws.jclaro.elpical.com/", "JobImplService"));
		StreamingAttachmentFeature stf = new StreamingAttachmentFeature(null, true, 4000000L);

		if (asMTOM)
			port = anis.getJobImplPort(new MTOMFeature(true,8000), stf);
		else
			port = anis.getJobImplPort();

		if (port==null)
			throw new Exception("JobClient getPort can not be retrieved");
		
		int i_timeout = 5; // in sec.		
		timeout = i_timeout * 1000;
		Map<String, Object> ctxt1 = ((BindingProvider)port).getRequestContext();
		ctxt1.put("com.sun.xml.ws.connect.timeout", timeout);
		ctxt1.put("com.sun.xml.ws.request.timeout", timeout);
		ctxt1.put(JAXWSProperties.HTTP_CLIENT_STREAMING_CHUNK_SIZE, 65536);

		return port;
	}
	
	/**
	 * Get a ClientID
	 * 
	 * @param port
	 * @return
	 */
	private static String getClientID(JobImpl port, byte[] userToken) {
		String ClientID = null;
		
		try {
			File ClientIDfile = new File("clid.txt");
			BufferedReader fr = null;
			BufferedWriter fw = null;
			
			if (ClientIDfile.exists()) {
				try {
					fr = new BufferedReader(new FileReader(ClientIDfile));
					String[] line_arr = fr.readLine().split("clid=");
					ClientID = line_arr[1];
				}
				catch (Exception ew) {
		        	System.out.println(ew.toString() + " ElpicalClaroWebservices_example getClientID 1");
		        }
				finally {
					try {
						fr.close();
					}
					catch (Exception e) {
			        	System.out.println(e.toString() + " ElpicalClaroWebservices_example getClientID 2");
			        }
				}
			}
			
			if (ClientID==null) {
				ClientID = port.getClientID(userToken);
				
				try {
					fw =  new BufferedWriter(new FileWriter(ClientIDfile));
					fw.write("clid="+ClientID+"\n");
				}
				catch (Exception ew) {
		        	System.out.println(ew.toString() + " ElpicalClaroWebservices_example getClientID 3");
		        }
				finally {
					try {
						fw.close();
					}
					catch (Exception e) {
			        	System.out.println(e.toString() + " ElpicalClaroWebservices_example getClientID 4");
			        }
				}	        
			} else {
				port.checkClientID(userToken, ClientID);
				
				checkError(userToken, ClientID);
			}
		} catch (Exception xLast) {
			System.out.println(xLast.getMessage());
		}
		
		return ClientID;
	}
	
	/**
	 * Check and report any error currently set in the JC WS.
	 * The error code and message will be cleared after the methods
	 * have been called.
	 */
	private static boolean checkError(byte[] userToken, String clientID) throws Exception {
		boolean result = false;

		// Global scope error
		// (when a clientID is not yet available or an invalid clientID is used)

		int errorCode = -1;
		String errorMsg = null;
		
		errorCode = port.getErrorCodeAsInteger(userToken);
		errorMsg = port.getErrorMessage(userToken);

		if (errorCode != -1) {
			result = true;

			System.out.println("errorCode = " + errorCode + "\n");
			System.out.println("errorMsg = " + (errorMsg == null ? "" : errorMsg) + "\n");

			// Handle error here, for example:

			//System.out.println(errorMsg);
			//throw new Exception(errorMsg);
		}

		// Client specific error (clientID)

		int errorCodeEx = -1;
		String errorMsgEx = null;

		errorCodeEx = port.getErrorCodeAsIntegerEx(userToken, clientID);
		errorMsgEx = port.getErrorMessageEx(userToken, clientID);

		if (errorCodeEx != -1) {
			result = true;

			System.out.println("errorCodeEx = " + errorCodeEx + "\n");
			System.out.println("errorMsgEx = " + (errorMsgEx == null ? "" : errorMsgEx) + "\n");

			// Handle error here, for example:

			//System.out.println(errorMsgEx);
			//throw new Exception(errorMsgEx);
		}

		return result;
	}
	
	/**
	 * @param args
	 * @throws Exception
	 */
	public static void main(String[] args) throws Exception {
		System.out.println("Starting webservices example");

		// Choose the method to be tested:
		final boolean testProcessImage = true;//false;
		final boolean testProcessJob = !testProcessImage;
		
		byte[] userToken = null;

		//WebServices properties 
//		System.setProperty("javax.xml.stream.XMLEventFactory","com.sun.xml.stream.events.ZephyrEventFactory");
//		System.setProperty("javax.xml.stream.XMLInputFactory","com.sun.xml.stream.ZephyrParserFactory");
//		System.setProperty("javax.xml.stream.XMLOutputFactory","com.sun.xml.stream.ZephyrWriterFactory");

		try {
			////
			
			// This is the only way to work with a self-signed certificate.
			
			// **** WARNING ****
			// Trusting all certificates allows man-in-the-middle attacks 
			// and is completely insecure.
			
			// Create a trust manager that does not validate certificate chains
			TrustManager[] trustAllCerts = new TrustManager[] { 
				new X509TrustManager() {
					/*
					 * (non-Javadoc)
					 * 
					 * @see javax.net.ssl.X509TrustManager#getAcceptedIssuers()
					 */
					public java.security.cert.X509Certificate[] getAcceptedIssuers() {
						return null;
					}
			
					public void checkClientTrusted(java.security.cert.X509Certificate[] certs, String authType) {
					}
			
					public void checkServerTrusted(java.security.cert.X509Certificate[] certs, String authType) {
					}
			} };
			
			// Install the all-trusting trust manager
			try {
			    SSLContext sc = SSLContext.getInstance("SSL");
			    
			    // NOTE: Set the second parameter to null to disable trust-all.
			    // NOTE: This applies when a certificate signed by a CA is used.
			    sc.init(null, trustAllCerts, new java.security.SecureRandom());
			    HttpsURLConnection.setDefaultSSLSocketFactory(sc.getSocketFactory());
			} catch (Exception xLast) {
				Logger.getGlobal().severe("Exception: " + xLast.getMessage());
			}

			////

			JobImpl port = getPort("192.168.178.21",8443,10,true);
			
			// Optionally you can enter a username and password here as 
			// configured in ClaroAdministration's user accounts.
			Account acc = port.login("", "");
			
			if (acc == null) {
				throw new Exception("Login failed: Account is null!");
			} else {
				userToken = acc.getEncryptedToken();
				
				if (userToken == null) {
					throw new Exception("Login failed: userToken is null!");
				}
			}
			
			String ClientID = getClientID(port, userToken);

			File imgfile = null;
			File jobimgfile = null;

			if (testProcessImage) {
				imgfile = new File("/temp/c0001.jpg");
			}

			// NOTE: Check issue 1035 in Redmine: It contains various sample job-tickets for S3, HTTPS, etc.
			if (testProcessImage) {
				jobimgfile = new File("/temp/c0001.job");
			} else {
				jobimgfile = new File("/temp/c0001_processJob.job");
			}

			List<String> channels = null;

			channels = port.getChannels(userToken);
			checkError(userToken, ClientID);
			
			String channel = channels.get(0);

			int jobid = 1;

			DataHandler dhimg = null;
			DataHandler dhjob = null;

			if (testProcessImage) {
				dhimg = new DataHandler(new FileDataSource(imgfile));
			}

			dhjob = new DataHandler(new FileDataSource(jobimgfile));

			System.out.print("processing file\n");

			if (testProcessImage) {
				// the 5th argument must be a filename without the extension.
				String imageFilename = imgfile.getName();
				String destinationImageFilename = imgfile.getName();
				destinationImageFilename = FilenameUtils.removeExtension(destinationImageFilename);

				port.processImage(userToken, dhjob, imageFilename, dhimg, destinationImageFilename, channel, ClientID, jobid);
			} else if (testProcessJob) {
				port.processJob(userToken, dhjob, channel, ClientID, jobid);
			}

			boolean hasError = checkError(userToken, ClientID);

			if (!hasError) {
				for (; ; ) {
					Thread.sleep(1000);

					List<JobStatus> infoMyJobs = port.getJobInfo(userToken, ClientID);

					for (JobStatus theJobStatus : infoMyJobs) {
						StringBuilder strJobInfo = new StringBuilder();
						strJobInfo.append("\n\n**** JobStatus ****\n\n");
						strJobInfo.append("ID = " + theJobStatus.getJobID() + "\n");
						strJobInfo.append("isJobFileSentToBadFolder = " + theJobStatus.isJobFileSentToBadFolder() + "\n");
						strJobInfo.append("isJobImageSentToBadFolder = " + theJobStatus.isJobImageSentToBadFolder() + "\n");
						strJobInfo.append("isSentToInspector = " + theJobStatus.isSentToInspector() + "\n");
						strJobInfo.append("isJobReady = " + theJobStatus.isJobReady() + "\n");
						strJobInfo.append("isJobTerminated = " + theJobStatus.isJobTerminated() + "\n");
						strJobInfo.append("getBadReason = " + theJobStatus.getBadReason() + "\n");
						strJobInfo.append("getBadReasonStr = " + theJobStatus.getBadReasonStr() + "\n");
						strJobInfo.append("getErrorMsg = " + theJobStatus.getErrorMsg() + "\n");
						strJobInfo.append("\n****\n\n");
						System.out.print(strJobInfo.toString());
					}

					int jobid_ready = port.getAnyJobReady(userToken, ClientID);

					hasError = checkError(userToken, ClientID);

					if (hasError) {
						break;
					}

					if (jobid_ready == jobid) {
						System.out.println("ready");
						break;
					}
					System.out.print(".");
				}
			}

			if (!hasError) {
				System.out.print("retrieving jobfile from server...");

				DataHandler dhjobret = (DataHandler) port.getJobFile(userToken, ClientID, jobid);
				checkError(userToken, ClientID);

				File jobfile_ret = null;

				if (testProcessImage) {
					jobfile_ret = new File("/temp/c0001_return.job");
				} else {
					jobfile_ret = new File("/temp/c0001_processJob_return.job");
				}

				FileOutputStream fos = new FileOutputStream(jobfile_ret);
				BufferedOutputStream output = new BufferedOutputStream(fos);

				try {
					dhjobret.writeTo(output);
				} catch (Exception e) {
					System.out.println(e.toString() + " ElpicalClaroWebservices_example main 1");
				} finally {
					try {
						output.close();
					} catch (Exception e) {
						System.out.println(e.toString() + " ElpicalClaroWebservices_example main 2");
					}

					try {
						fos.close();
					} catch (Exception e) {
						System.out.println(e.toString() + " ElpicalClaroWebservices_example main 3");
					}
				}

				if (testProcessImage) {
					System.out.print("done\nretrieving imagefile from server...");

					DataHandler dhimgret = null; // _return

					////
					// DownloadThread#downloadAndParseJobFile

					dhjobret = (DataHandler) port.getJobFile(userToken, ClientID, jobid);
					checkError(userToken, ClientID);

					ByteArrayOutputStream byteStream = new ByteArrayOutputStream();
					dhjobret.writeTo(byteStream);

					 try (ByteArrayInputStream in = new ByteArrayInputStream(byteStream.toByteArray())) {
						DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();

						factory.setIgnoringComments(true);
						factory.setIgnoringElementContentWhitespace(true);
						factory.setValidating(false);

						DocumentBuilder builder = factory.newDocumentBuilder();
						Document doc = builder.parse(in);

						// get the returnfilename
						XPathFactory xPathFactory = XPathFactory.newInstance();
						XPath xpath = xPathFactory.newXPath();
						try {
							XPathExpression returnFileNamePath = xpath.compile("/ElpicalClaro/ImageName");
							Node returnFileNameNode = (Node) returnFileNamePath.evaluate(doc, XPathConstants.NODE);
							String returnFileName = returnFileNameNode.getTextContent();

							dhimgret = (DataHandler) port.getImageFile(userToken, ClientID, jobid, returnFileName/*"c0001_return.jpeg"*/, false);
						} catch (Exception e2) {
							Logger.getGlobal().fine("Download thread Error retrieving return filename from jobticket");
							Logger.getGlobal().severe("Error retrieving return filename from jobticket");
							throw e2;
						}
					 } catch (Exception e) {
						 Logger.getGlobal().fine("Download thread Error parsing return jobticket: " + PrintStackTrace.print(e));
						 Logger.getGlobal().severe("Error parsing return jobticket: " + e.toString());
						 throw e;
					 }
					////

					checkError(userToken, ClientID);

					File imgfile_ret = null;
					imgfile_ret = new File("/temp/c0001_return.jpeg");

					fos = new FileOutputStream(imgfile_ret);
					output = new BufferedOutputStream(fos);

					try {
						dhimgret.writeTo(output);
					} catch (Exception e) {
						System.out.println(e.toString() + " ElpicalClaroWebservices_example main 4");
					} finally {
						try {
							output.close();
						} catch (Exception e) {
							System.out.println(e.toString() + " ElpicalClaroWebservices_example main 5");
						}

						try {
							fos.close();
						} catch (Exception e) {
							System.out.println(e.toString() + " ElpicalClaroWebservices_example main 6");
						}
					}
				}
			}
			
			System.out.print("done\ncleaning up server...");
			
			port.removeJob(userToken, ClientID,jobid);
			checkError(userToken, ClientID);
			
			System.out.println("done");
		} catch (Exception e) {
			System.out.println(e.getMessage());
		}
		
		System.out.println("Finshised webservices example");
	}
}